/////////////////////////////////////////////////////
// JavaScript objects to build
// URLscript Commands Interfaces
/////////////////////////////////////////////////////

////////////////////////////////////////////////////////
////////////////////////////////////////////////////////
// to include with the following SCRIPT tag
// <SCRIPT langage="JavaScript1.1" SRC="dmCmd.js"></SCRIPT>

//---------------------------------------------------
// Application 	: *
// File 	: dmCmd.js
// Author 	: JM Inglebert
// Institution  : VALORIA/ORCADE
// Mail 	: Jean-Michel.Inglebert@univ-ubs.fr
// Date		: 16/04/98
//---------------------------------------------------
   function rcsId(){ return "$Id: dmCmd.js,v 1.1 1998/05/01 07:49:18 queinnec Exp $" }
//---------------------------------------------------
// x 
// x
//---------------------------------------------------
// TODO
// - redo interface si modification des datas de session
// - revoir les parties optionnelles
// - raz des radios
// TODO
//---------------------------------------------------
////////////////////////////////////////////////////////
////////////////////////////////////////////////////////


////////////////////////////////////////////////////////
////////////////////////////////////////////////////////
// Command object describe URLscript command and can
// build a JavaScript Form to capture args values
////////////////////////////////////////////////////////
////////////////////////////////////////////////////////
// Command Object Constructor

function Command(name,result,arg1,arg2,etc)
// name   : string # URLscript command name
// result : string # returned type
// arg1   : Arg    # optionnal # first URLscript argument description
// arg2   : Arg    # optionnal # 
// ...
// argN   : Arg    # optionnal # 
{
 this.name        = name
 this.result      = result
 this.args        = new Array()
  for (var i=2,j=0;i<Command.arguments.length;i++,j++)
  {this.args[j]=Command.arguments[i]}

 /////// methods ///////
 this.doI = doCommandInterface
}

////////////////////////////////////////////////////////
////////////////////////////////////////////////////////
// Arg object describe a URLscript command argument
// and can build a JavaScript element to capture its value
////////////////////////////////////////////////////////
////////////////////////////////////////////////////////
// Arg Object Constructor

function Arg(name,items,values,dflt,builderf,handlerCode)
// name   : string          # arg name
// items  : string Array    # arg possible items names
// values : string Array    # arg corresponding DMeroon values
// dflt   : string or Array # arg default item(s) names
// builderf      : function # arg interface builder function
// handlerCode   : string   # interface element handler code
{
 this.name     = name
 this.items    = items
 this.values   = values
 this.dflt     = dflt
 this.handler  = handlerCode

 /////// methods ///////
 this.doI      = builderf
}


////////////////////////////////////////////////////////
////////////////////////////////////////////////////////
////////////////////////////////////////////////////////


//-------------------------------------------------
// Procedure doCommandInterface
// ---
// Default command interface builder
// ---

function doCommandInterface(win,libWinLoc,finalActionHandler)
// win       # target window where to send JavaScript interface code
// libWinLoc # window location where handlers are loaded
// finalActionHandler # (optionnal) final action executed by handler assigned to Command button
{
 var CommandHandler = libWinLoc + ".CommandHandler(this.form,\"" + finalActionHandler + "\")"

 win.document.write ("<FORM>")

 win.document.write("<TABLE BORDER><TR>")

 // show the DMeroon signature (a minimum help)
 for (var i = 0; i < this.args.length ; i++)
  {
    win.document.write("<TH><FONT SIZE=-2>")
    win.document.write(this.args[i].name)
    win.document.write("</FONT></TH>")
  }
// win.document.write("<TH> <B>" + this.name + " --></B> " + this.result + "</TH>")
 win.document.write("</TR>")

 win.document.write("<TR>")
 // build each arg interface
 for (var i = 0; i < this.args.length ; i++)
  {
    win.document.write("<TD><FONT SIZE=-1>")
    this.args[i].doI(win)
    win.document.write("</FONT></TD>")
  }
 win.document.write("</TR></TABLE>")

// win.document.write ("<CENTER>")
 // build the Command button
 doInput(win,"button",this.name,this.name,"","onClick",CommandHandler)

 win.document.write("<B> --> </B> " + this.result + "  ")

 // build optionnal supplemantary commands interfaces
 win.document.write ("<B> Optionnal parts </B>")

 // define command if --> new Object
 if (this.result == "new Object")
  {
   win.document.write ("<B> [ </B>")
   doInput(win,"text","objectName","?new_name?","?new_name?".length)
   doChecks(win,"checkbox",new Array("define"),new Array("define"),"define",
            "this.form.objectName.value=((this.checked)?\"?new_name?\":\"\")",0)
   win.document.write ("<B> ] </B>")
  }

 win.document.write ("<B> [ </B>")

 // stack commands
 doChecks(win,"radio",dmStackCommands,dmStackCommands,"stackCommand","",-1)

 win.document.write ("<B> ] </B>")
// win.document.write ("</CENTER>")

 win.document.write ("</FORM>")

}

//-------------------------------------------------
// Procedure CommandHandler
// ---
// Default command handler : grab URLscript code
// and execute the optionnal final statment
// ---

function CommandHandler(form,lastStat)
{
 var dmCommand=grabCode(form)
 if (lastStat != "undefined") {eval(lastStat)}
}

// -----------------------------------
// Function grabCode
// ---
// collect value from each element of the given form
// and build the returned command
// ---

function grabCode(form)
// form   # form to scan to make command from each element
// return # the grabbed command string
{
 var command = ""

 for (var i=0;i<form.elements.length;i++)
 {
  var type = form.elements[i].type

  if (type == "select-one")
  {
   command += form.elements[i].options[form.elements[i].options.selectedIndex].value
   command += " "
   continue
  }
  if (type == "select-multiple")
  {
   for (var j=0,cumul=0; j<form.elements[i].length;j++)
   {
    if (form.elements[i].options[j].selected == true)
     {
      cumul |= parseInt(form.elements[i].options[j].value)
     }
   }
   command += cumul
   command += " "
   continue
  }
  if (type == "text")
  {
   if (form.elements[i].value && (form.elements[i].value != "null"))
   {
    // Nat3 input
    if (form.elements[i].name=="Nat3")
     {command += parseInt(form.elements[i].value) }
    else
      // literal string input
      if (form.elements[i].name=="string")
       {
        allObjectNames[allObjectNames.length] = "\"" + form.elements[i].value + "\""
        allObjectNamesValues[allObjectNamesValues.length] = "\"" + form.elements[i].value + "\""
       }
      else
        // fields path input
        if (form.elements[i].name==".fields")
         {command = command.substring(0,command.length-1) + form.elements[i].value }
        else
         {command += "\"" + form.elements[i].value + "\""}

    // separator
    command += " "
   }
   continue
  }
  if (type == "button")
  {
   command += form.elements[i].value
   command += " "
   // push name if define
   if (form.elements[i].value=="define")
    {
     allObjectNames[allObjectNames.length] = form.elements[i-1].value
     allObjectNamesValues[allObjectNamesValues.length] = form.elements[i-1].value
    }
   continue
  }
  if (type == "radio")
  {
   if (form.elements[i].checked)
   {
    command += form.elements[i].value
    command += " "
   }
   continue
  }
  if (type == "checkbox")
  {
   // hyp : a checkbox is preceded by a corresponding input text
   if ((form.elements[i].checked) && (form.elements[i-1].value))
   {
    command += form.elements[i].value
    command += " "
    // the define checkbox
    if (form.elements[i].name=="define")
    {
     allObjectNames[allObjectNames.length] = form.objectName.value
     allObjectNamesValues[allObjectNamesValues.length] = form.objectName.value
    }
    // the createsubclass case
    if (form.elements[i-2].name=="createsubclass")
    {
     allClassNames[allClassNames.length] = form.objectName.value
     allClassNamesValues[allClassNamesValues.length] = form.objectName.value
    }
   }
   continue
  }
  alert(type)
 }
 //
 command += "\n"
 if (debug) {alert(command)}
 return(command)
}


////////////////////////////////////////////////////////
////////////////////////////////////////////////////////
// ---
// Some wrappers to formLib.js functions
// ---
function doT(win)
{
 with (this)
  {
   if (handler=="")
    {doInput(win,"text",name,dflt,dflt.length)}
   else
    {doInput(win,"text",name,dflt,dflt.length,"onChange",handler)}
  }
}
function doS(win)
{
 with (this)
  {
   doSelect(win,items,values,name,handler,dflt)
  }
}
function doB(win)
{
 with (this)
  {
   doInput(win,"button",name,dflt,dflt.length)
  }
}
////////////////////////////////////////////////////////
////////////////////////////////////////////////////////

// -----------------------------------
// function realizeCommand()
// ---
// collect value from each element of the given form
// and build the returned command
// ---

function realizeCommand(win,libWin,cmdObjectName)
// win # target window
// libWin # window where handler are loaded
// cmdObjectName # JS URLscript command object name
// return # handler string action to create command interface
{ 
 var cmdString = ""
 cmdString += win + ".document.clear();"
 cmdString += cmdObjectName + ".doI("
 cmdString += win + ","
 cmdString += libWin + ","
 cmdString += "\"top.scriptFrame.document.scriptF.editTA.value += dmCommand\""
 cmdString += ");"
 cmdString += win + ".document.close()"

 
 return(cmdString)

}
