;;; $Id: apitest1.scm,v 1.2 1995/12/29 18:05:23 queinnec Exp $

;;; This file tests requests exchange in an unique Scheme process
;;; holding two sites. It redefines the DM-signal and DM-wait
;;; functions used in api.scm to simulate a DMeroon space with two
;;; sites.

(define other-site
  (DM-make DM-Site-class
           "other"
           0 0                          ; ip, port
           2.78                         ; version
           DM-nil                       ; information
           314                          ; processid
           (DM-make DM-Clock-class 0 0) ; clock
           0                            ; clocker
           (DM-make DM-Connection-class ; connection
                    23                  ; number
                    5                   ; retries
                    0                   ; options
                    0 0 0 0             ; family port address zero (sockaddr)
                    0                   ; read
                    0                   ; written
                    DM-nil              ; reception
                    DM-nil              ; emission
                    0                   ; clocker
                    DM-site-surrogate   ; site
                    (DM-create 'queue)  ; objects
                    )
           (DM-create 'Hashtable 16)    ; exits
           (DM-create 'Hashtable 16)    ; entries
           (DM-create 'MutableVector 256) ; ports
           '()                          ; objects
           (DM-create 'Hashtable 16)    ; oblist
           ) )

;;; A little utility to allocate and initialize some useful values.

(define (DM-create classname . sizes)
  (case classname
    ((queue)
     (let ((q (list 999)))
       (set-car! q q)
       q ) )
    ((Hashtable) 
     (let ((h (DM-allocate DM-Hashtable-class (car sizes))))
       (do ((i 0 (+ i 1)))
           ((>= i (car sizes)) h)
         (DM-local-set DM-reference-type h DM-Hashtable-item-field 
                       DM-nil ) ) ) )
    ((MutableVector) 
     (let ((h (DM-allocate DM-MutableVector-class (car sizes))))
       (do ((i 0 (+ i 1)))
           ((>= i (car sizes)) h)
         (DM-local-set DM-reference-type h DM-MutableVector-item-field
                       DM-nil ) ) ) )
    (else (DM-error 'DM-create "Unknown class" classname)) ) )


;;; DM-signal is called when a communication event occurs.  The
;;; argument can be a Site meaning that an object was sent to that
;;; site or a connection meaning that an object has to be sent through
;;; that connection.

(define (DM-signal event)
  ? )

;;; DM-wait is called when some event is waited for. The argument can
;;; be a Site meaning that we wait for an object to be sent, a Request
;;; meaning that we wait for the answer to that request.

(define (DM-wait event)
  ? )

;;; end of apitest1.scm
