;;; $Id$
;;; Create and publish a mutable class with all known types of fields.

(DM-define-class Test Object
   ((nat1 	:type nat1 :mutable)
    (nat2  	:type nat2 :mutable)
    (nat3  	:type nat3 :mutable)
    (nat4  	:type nat4 :mutable)
    (reference 	:type reference :mutable)
    (data      	:type data :mutable)
    ;;(code      	:type code :mutable)
    (int1  	:type int1 :mutable)
    (int2  	:type int2 :mutable)
    (int3  	:type int3 :mutable)
    (int4  	:type int4 :mutable)
    (char1  	:type char1 :mutable)
    ;;(netnat2  	:type netnat2 :mutable)
    ;;(netnat3  	:type netnat3 :mutable)
    (float1  	:type float1 :mutable)
    (float2  	:type float2 :mutable)
    ;;(float3  	:type float3 :mutable)
    ;(date  	:type date :mutable)
    ;; now some indexed fields
    (chars1  	:type char1 :indexing-type nat1 :mutable)
    ) )

(DM-publish! 
 (let ((o (DM-allocate Test-class 4)))
   (define (setfield! i v)
     (DM-set-field-value!
      o (DM-indexed-field-value Test-class DM-Class-field-field i) v ) )
   (define (setindexedfield! i j v)
     (DM-set-indexed-field-value!
      o (DM-indexed-field-value Test-class DM-Class-field-field i) j v ) )
   (setfield! 0 123)                    ; nat1
   (setfield! 1 65001)                  ; nat2
   (setfield! 2 75321)                  ; nat3
   (setfield! 3 75321)                  ; nat4
   (setfield! 4 DM-site)                ; reference
   (setfield! 5 #f)                     ; data
   (setfield! 6 -123)                   ; int1
   (setfield! 7 -5001)                  ; int2
   (setfield! 8 -75321)                 ; int3
   ;;   (setfield! 9 -75321)                 ; int4
   (setfield! 10 #\Q)                   ; char1
   (setfield! 11 3.14)                  ; float1
   (setfield! 12 -3.14e-31)             ; float2
   (setindexedfield! 13 0 #\F)          ; nat1*char1
   (setindexedfield! 13 1 #\o)          ; nat1*char1
   (setindexedfield! 13 2 #\O)          ; nat1*char1
   (DM-set-initialized! o)
   o )
 "user" "mutableThing" )

;;; end of mutcls.scm
